--- //depot/vendor/freebsd/src/sys/netatalk/ddp_input.c	2005/01/07 02:37:15
+++ //depot/user/rwatson/netperf/sys/netatalk/ddp_input.c	2005/02/27 16:23:38
@@ -76,6 +76,11 @@
 static volatile int	ddp_firewall = 0;
 static struct ddpstat	ddpstat;
 
+/*
+ * XXXRW: If we're going to keep this cached route data, we'll need to lock it
+ * down, and change later function-local use of it to grab an extra reference
+ * after deciding it is useful.
+ */
 static struct route	forwro;
 
 static void     ddp_input(struct mbuf *, struct ifnet *, struct elaphdr *, int);
@@ -170,6 +175,7 @@
 	 * Make sure that we point to the phase1 ifaddr info 
 	 * and that it's valid for this packet.
 	 */
+	AT_IFADDR_LIST_LOCK();
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 	    if ((aa->aa_ifp == ifp)
 	    && ((aa->aa_flags & AFA_PHASE2) == 0)
@@ -185,6 +191,8 @@
 	    m_freem(m);
 	    return;
 	}
+	IFAREF((struct ifaddr *)aa);
+	AT_IFADDR_LIST_UNLOCK();
     } else {
 	/*
 	 * There was no 'elh' passed on. This could still be
@@ -229,6 +237,7 @@
 	     * this node number will match (which may NOT be what we want,
 	     * but it's probably safe in 99.999% of cases.
 	     */
+	    AT_IFADDR_LIST_LOCK();
 	    for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		if (phase == 1 && (aa->aa_flags & AFA_PHASE2)) {
 		    continue;
@@ -243,11 +252,15 @@
 		    break;
 		}
 	    }
+	    if (aa != NULL)
+		IFAREF((struct ifaddr *)aa);
+	    AT_IFADDR_LIST_UNLOCK();
 	} else {
 	    /* 
 	     * A destination network was given. We just try to find 
 	     * which ifaddr info matches it.
 	     */
+	    AT_IFADDR_LIST_LOCK();
 	    for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		/*
 		 * This is a kludge. Accept packets that are
@@ -281,6 +294,9 @@
 		}
 		break;
 	    }
+	    if (aa != NULL)
+		IFAREF((struct ifaddr *)aa);
+	    AT_IFADDR_LIST_UNLOCK();
 	}
     }
 
@@ -293,6 +309,8 @@
     if (mlen < dlen) {
 	ddpstat.ddps_toosmall++;
 	m_freem(m);
+	if (aa != NULL)
+	    IFAFREE((struct ifaddr *)aa);
 	return;
     }
     if (mlen > dlen) {
@@ -315,6 +333,8 @@
 	 */
 	if (ddp_forward == 0) {
 	    m_freem(m);
+	    if (aa != NULL)
+		IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
 	/* 
@@ -359,6 +379,8 @@
 	&& ((forwro.ro_rt == NULL)
 	  || (forwro.ro_rt->rt_ifp != ifp))) {
 	    m_freem(m);
+	    if (aa != NULL)
+		IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
 
@@ -376,6 +398,8 @@
 	} else {
 	    ddpstat.ddps_forward++;
 	}
+	if (aa != NULL)
+	    IFAFREE((struct ifaddr *)aa);
 	return;
     }
 
@@ -440,6 +464,8 @@
     DDP_LIST_SUNLOCK();
     if (m != NULL)
 	m_freem(m);
+    if (aa != NULL)
+	IFAFREE((struct ifaddr *)aa);
 }
 
 #if 0
--- //depot/vendor/freebsd/src/sys/netatalk/ddp_output.c	2005/07/05 23:40:38
+++ //depot/user/rwatson/netperf/sys/netatalk/ddp_output.c	2005/07/19 11:47:08
@@ -151,6 +151,7 @@
     && (ro->ro_rt->rt_ifa)
     && (ifp = ro->ro_rt->rt_ifa->ifa_ifp)) {
 	net = ntohs(satosat(ro->ro_rt->rt_gateway)->sat_addr.s_net);
+	AT_IFADDR_LIST_LOCK();
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 	    if (((net == 0) || (aa->aa_ifp == ifp)) &&
 		    net >= ntohs(aa->aa_firstnet) &&
@@ -158,6 +159,8 @@
 		break;
 	    }
 	}
+	IFAREF((struct ifaddr *)aa);
+	AT_IFADDR_LIST_UNLOCK();
     } else {
 	m_freem(m);
 #ifdef NETATALK_DEBUG
@@ -177,6 +180,8 @@
 	    ifp->if_xname);
 #endif
 	m_freem(m);
+	if (aa != NULL)
+	    IFAFREE((struct ifaddr *)aa);
 	return (ENETUNREACH);
     }
 
@@ -203,6 +208,8 @@
 	MGET(m0, M_DONTWAIT, MT_HEADER);
 	if (m0 == NULL) {
 	    m_freem(m);
+	    if (aa != NULL)
+		IFAFREE((struct ifaddr *)aa);
 	    printf("ddp_route: no buffers\n");
 	    return (ENOBUFS);
 	}
@@ -236,9 +243,13 @@
     if ((satosat(&aa->aa_addr)->sat_addr.s_net  == satosat(&ro->ro_dst)->sat_addr.s_net) &&
 	(satosat(&aa->aa_addr)->sat_addr.s_node == satosat(&ro->ro_dst)->sat_addr.s_node))
     {
+	if (aa != NULL)
+	    IFAFREE((struct ifaddr *)aa);
 	return (if_simloop(ifp, m, gate.sat_family, 0));
     }
 
+    if (aa != NULL)
+	IFAFREE((struct ifaddr *)aa);
     return ((*ifp->if_output)(ifp,
 	m, (struct sockaddr *)&gate, NULL)); /* XXX */
 }
--- //depot/vendor/freebsd/src/sys/netatalk/ddp_pcb.c	2005/01/07 02:37:15
+++ //depot/user/rwatson/netperf/sys/netatalk/ddp_pcb.c	2005/02/27 16:23:38
@@ -64,6 +64,7 @@
     struct sockaddr_at	lsat, *sat;
     struct at_ifaddr	*aa;
     struct ddpcb	*ddpp;
+    int error;
 
     /*
      * We read and write both the ddp passed in, and also ddp_ports.
@@ -71,37 +72,46 @@
     DDP_LIST_XLOCK_ASSERT();
     DDP_LOCK_ASSERT(ddp);
 
-    if (ddp->ddp_lsat.sat_port != ATADDR_ANYPORT) { /* shouldn't be bound */
-	return (EINVAL);
+    error = 0;
+    if (ddp->ddp_lsat.sat_port != ATADDR_ANYPORT) {
+	/* shouldn't be bound */
+	error = EINVAL;
+	goto out;
     }
 
     if (addr != NULL) {			/* validate passed address */
 	sat = (struct sockaddr_at *)addr;
 	if (sat->sat_family != AF_APPLETALK) {
-	    return (EAFNOSUPPORT);
+	    error = EAFNOSUPPORT;
+	    goto out;
 	}
 
 	if (sat->sat_addr.s_node != ATADDR_ANYNODE ||
 		sat->sat_addr.s_net != ATADDR_ANYNET) {
+	    AT_IFADDR_LIST_LOCK();
 	    for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		if ((sat->sat_addr.s_net == AA_SAT(aa)->sat_addr.s_net) &&
 		 (sat->sat_addr.s_node == AA_SAT(aa)->sat_addr.s_node)) {
 		    break;
 		}
 	    }
-	    if (!aa) {
-		return (EADDRNOTAVAIL);
+	    AT_IFADDR_LIST_UNLOCK();
+	    if (aa != NULL) {
+		error = EADDRNOTAVAIL;
+		goto out;
 	    }
 	}
 
 	if (sat->sat_port != ATADDR_ANYPORT) {
 	    if (sat->sat_port < ATPORT_FIRST ||
 		    sat->sat_port >= ATPORT_LAST) {
-		return (EINVAL);
+		error = EINVAL;
+		goto out;
 	    }
 	    if (sat->sat_port < ATPORT_RESERVED &&
 		 suser(td)) {
-		return (EACCES);
+		error = EACCES;
+		goto out;
 	    }
 	}
     } else {
@@ -116,7 +126,8 @@
     if (sat->sat_addr.s_node == ATADDR_ANYNODE &&
 	    sat->sat_addr.s_net == ATADDR_ANYNET) {
 	if (at_ifaddr_list == NULL) {
-	    return (EADDRNOTAVAIL);
+	    error = EADDRNOTAVAIL;
+	    goto out;
 	}
 	sat->sat_addr = AA_SAT(at_ifaddr_list)->sat_addr;
     }
@@ -133,7 +144,8 @@
 	    }
 	}
 	if (sat->sat_port == ATPORT_LAST) {
-	    return (EADDRNOTAVAIL);
+	    error = EADDRNOTAVAIL;
+	    goto out;
 	}
 	ddp->ddp_lsat.sat_port = sat->sat_port;
 	ddp_ports[ sat->sat_port - 1 ] = ddp;
@@ -146,7 +158,8 @@
 	    }
 	}
 	if (ddpp != NULL) {
-	    return (EADDRINUSE);
+	    error = EADDRINUSE;
+	    goto out;
 	}
 	ddp->ddp_pnext = ddp_ports[ sat->sat_port - 1 ];
 	ddp_ports[ sat->sat_port - 1 ] = ddp;
@@ -155,7 +168,8 @@
 	}
     }
 
-    return (0);
+out:
+    return (error);
 }
 
 int
@@ -201,6 +215,7 @@
 	}
 	aa = NULL;
 	if ((ifp = ro->ro_rt->rt_ifp) != NULL) {
+	    AT_IFADDR_LIST_LOCK();
 	    for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		if (aa->aa_ifp == ifp &&
 			ntohs(net) >= ntohs(aa->aa_firstnet) &&
@@ -208,6 +223,7 @@
 		    break;
 		}
 	    }
+	    AT_IFADDR_LIST_UNLOCK();
 	}
 	if (aa == NULL || (satosat(&ro->ro_dst)->sat_addr.s_net !=
 		(hintnet ? hintnet : sat->sat_addr.s_net) ||
@@ -238,11 +254,13 @@
      */
     aa = NULL;
     if (ro->ro_rt && (ifp = ro->ro_rt->rt_ifp)) {
+        AT_IFADDR_LIST_LOCK();
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 	    if (aa->aa_ifp == ifp) {
 		break;
 	    }
 	}
+        AT_IFADDR_LIST_UNLOCK();
     }
     if (aa == NULL) {
 	return (ENETUNREACH);
@@ -279,6 +297,10 @@
 	DDP_LOCK_INIT(ddp);
 	ddp->ddp_lsat.sat_port = ATADDR_ANYPORT;
 
+	/*
+	 * XXXRW: Is this unlocked assignment payer for socket and
+	 * back-pointer something that needs to be protected?
+	 */
 	ddp->ddp_socket = so;
 	so->so_pcb = (caddr_t)ddp;
 
--- //depot/vendor/freebsd/src/sys/netatalk/ddp_usrreq.c	2005/02/18 10:57:04
+++ //depot/user/rwatson/netperf/sys/netatalk/ddp_usrreq.c	2005/02/27 16:23:38
@@ -44,6 +44,11 @@
 #include <netatalk/ddp_pcb.h>
 #include <netatalk/at_extern.h>
 
+/*
+ * XXXRW: These structures are currently not mutable.  They're not marked
+ * with 'const' because I suspect that consumers of this code would like for
+ * them to be mutable someday.
+ */
 static u_long	ddp_sendspace = DDP_MAXSZ; /* Max ddp size + 1 (ddp_type) */
 static u_long	ddp_recvspace = 10 * (587 + sizeof(struct sockaddr_at));
 
@@ -170,6 +175,13 @@
 	return (0);
 }
 
+/*
+ * XXXRW: If an explicit address is specified, then we temporarily change
+ * the address on the pcb for sending.  This is inefficient because it
+ * requires us to perform global rather than pcb-local operations.  It
+ * may also create a race if other users of the socket are simultaneously
+ * sending.
+ */
 static int
 ddp_send(struct socket *so, int flags, struct mbuf *m, struct sockaddr *addr,
             struct mbuf *control, struct thread *td)
--- //depot/vendor/freebsd/src/sys/netgraph/ng_base.c	2005/07/05 17:37:36
+++ //depot/user/rwatson/netperf/sys/netgraph/ng_base.c	2005/07/19 11:47:08
@@ -3088,6 +3088,7 @@
 		ng_qzone = uma_zcreate("NetGraph items", sizeof(struct ng_item),
 		    NULL, NULL, NULL, NULL, UMA_ALIGN_CACHE, 0);
 		uma_zone_set_max(ng_qzone, maxalloc);
+		/* XXX could use NETISR_MPSAFE but need to verify code */
 		netisr_register(NETISR_NETGRAPH, (netisr_t *)ngintr, NULL,
 		    NETISR_MPSAFE);
 		break;
--- //depot/vendor/freebsd/src/sys/netgraph/ng_ksocket.c	2005/05/16 17:10:18
+++ //depot/user/rwatson/netperf/sys/netgraph/ng_ksocket.c	2005/06/01 10:10:04
@@ -1005,6 +1005,9 @@
  * To decouple stack, we use queue version of ng_send_fn().
  */
 
+/*
+ * XXXRW: ng_ksocket_incoming() is called without Giant.  Is that OK?
+ */
 static void
 ng_ksocket_incoming(struct socket *so, void *arg, int waitflag)
 {
--- //depot/vendor/freebsd/src/sys/netinet/accf_http.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netinet/accf_http.c	2005/02/27 16:23:38
@@ -161,6 +161,7 @@
 sohashttpget(struct socket *so, void *arg, int waitflag)
 {
 
+	/* Unlocked read. */
 	if ((so->so_rcv.sb_state & SBS_CANTRCVMORE) == 0 && !sbfull(&so->so_rcv)) {
 		struct mbuf *m;
 		char *cmp;
@@ -214,6 +215,7 @@
 	struct mbuf *m, *n;
 	int	i, cc, spaces, inspaces;
 
+	/* Unlocked read. */
 	if ((so->so_rcv.sb_state & SBS_CANTRCVMORE) != 0 || sbfull(&so->so_rcv))
 		goto fallout;
 
@@ -301,6 +303,7 @@
 	int ccleft, copied;
 
 	DPRINT("start");
+	/* Unlocked read. */
 	if ((so->so_rcv.sb_state & SBS_CANTRCVMORE) != 0 || sbfull(&so->so_rcv))
 		goto gotit;
 
--- //depot/vendor/freebsd/src/sys/netinet/if_ether.c	2005/06/05 03:15:31
+++ //depot/user/rwatson/netperf/sys/netinet/if_ether.c	2005/07/05 14:55:33
@@ -101,6 +101,11 @@
 #define la_timer la_rt->rt_rmx.rmx_expire /* deletion time in seconds */
 };
 
+/*
+ * XXXRW: Need to document (and/or fix) locking for this.  We always
+ * seem to hold a lock (and assert) when referencing this list, but it's
+ * not clear it's always the same lock.
+ */
 static	LIST_HEAD(, llinfo_arp) llinfo_arp;
 
 static struct	ifqueue arpintrq;
--- //depot/vendor/freebsd/src/sys/netinet/igmp.c	2005/03/26 22:25:15
+++ //depot/user/rwatson/netperf/sys/netinet/igmp.c	2005/06/01 10:10:04
@@ -99,6 +99,9 @@
 static u_long igmp_all_hosts_group;
 static u_long igmp_all_rtrs_group;
 
+/*
+ * XXXRW: These variables make me vaguely nervous.
+ */
 static struct mbuf *router_alert;
 static struct route igmprt;
 
@@ -123,6 +126,7 @@
 
 	/*
 	 * Construct a Router Alert option to use in outgoing packets
+	 * XXXRW: This might actually need a MAC label.
 	 */
 	MGET(router_alert, M_DONTWAIT, MT_DATA);
 	ra = mtod(router_alert, struct ipoption *);
--- //depot/vendor/freebsd/src/sys/netinet/in_gif.c	2005/06/20 08:42:36
+++ //depot/user/rwatson/netperf/sys/netinet/in_gif.c	2005/07/05 14:55:33
@@ -174,6 +174,9 @@
 	}
 	bcopy(&iphdr, mtod(m, struct ip *), sizeof(struct ip));
 
+	/*
+	 * XXXRW: locking of gif's softc.
+	 */
 	if (dst->sin_family != sin_dst->sin_family ||
 	    dst->sin_addr.s_addr != sin_dst->sin_addr.s_addr) {
 		/* cache route doesn't match */
@@ -335,6 +338,10 @@
 	case 0: case 127: case 255:
 		return 0;
 	}
+
+	/*
+	 * XXXRW: Lock in_ifaddrhead walking.
+	 */
 	/* reject packets with broadcast on source */
 	TAILQ_FOREACH(ia4, &in_ifaddrhead, ia_link) {
 		if ((ia4->ia_ifa.ifa_ifp->if_flags & IFF_BROADCAST) == 0)
@@ -343,6 +350,7 @@
 			return 0;
 	}
 
+	/* XXXRW: unlocked read. */
 	/* ingress filters on outer source */
 	if ((GIF2IFP(sc)->if_flags & IFF_LINK2) == 0 && ifp) {
 		struct sockaddr_in sin;
@@ -398,6 +406,11 @@
 in_gif_attach(sc)
 	struct gif_softc *sc;
 {
+	
+	/*
+	 * XXXRW: Technically, NULL can also be returned for ENOMEM,
+	 * not just EEXIST.
+	 */
 	sc->encap_cookie4 = encap_attach_func(AF_INET, -1, gif_encapcheck,
 	    &in_gif_protosw, sc);
 	if (sc->encap_cookie4 == NULL)
--- //depot/vendor/freebsd/src/sys/netinet/in_pcb.c	2005/06/01 11:45:18
+++ //depot/user/rwatson/netperf/sys/netinet/in_pcb.c	2005/07/05 14:55:33
@@ -702,6 +702,7 @@
 #ifdef IPSEC
 	ipsec_pcbdisconn(inp->inp_sp);
 #endif
+	/* Unlocked read. */
 	if (inp->inp_socket->so_state & SS_NOFDREF)
 		in_pcbdetach(inp);
 }
@@ -774,6 +775,10 @@
 	struct in_addr addr;
 	in_port_t port;
 
+	/*
+	 * XXXRW: Why not use the inpcb lock instead of the info lock
+	 * here?
+	 */
 	s = splnet();
 	INP_INFO_RLOCK(pcbinfo);
 	inp = sotoinpcb(so);
@@ -782,10 +787,8 @@
 		splx(s);
 		return ECONNRESET;
 	}
-	INP_LOCK(inp);
 	port = inp->inp_lport;
 	addr = inp->inp_laddr;
-	INP_UNLOCK(inp);
 	INP_INFO_RUNLOCK(pcbinfo);
 	splx(s);
 
@@ -807,6 +810,10 @@
 	struct in_addr addr;
 	in_port_t port;
 
+	/*
+	 * XXXRW: Why not use the inpcb lock instead of the info lock
+	 * here?
+	 */
 	s = splnet();
 	INP_INFO_RLOCK(pcbinfo);
 	inp = sotoinpcb(so);
@@ -815,10 +822,8 @@
 		splx(s);
 		return ECONNRESET;
 	}
-	INP_LOCK(inp);
 	port = inp->inp_fport;
 	addr = inp->inp_faddr;
-	INP_UNLOCK(inp);
 	INP_INFO_RUNLOCK(pcbinfo);
 	splx(s);
 
--- //depot/vendor/freebsd/src/sys/netinet/ip_divert.c	2005/05/13 11:46:15
+++ //depot/user/rwatson/netperf/sys/netinet/ip_divert.c	2005/06/01 10:10:04
@@ -373,6 +373,9 @@
 			m->m_pkthdr.rcvif = ifa->ifa_ifp;
 		}
 #ifdef MAC
+		/*
+		 * XXXRW: perhaps should be mac_create_mbuf_from_inpcb()?
+		 */
 		SOCK_LOCK(so);
 		mac_create_mbuf_from_socket(so, m);
 		SOCK_UNLOCK(so);
@@ -421,6 +424,7 @@
 	inp->inp_vflag |= INP_IPV4;
 	inp->inp_flags |= INP_HDRINCL;
 	INP_UNLOCK(inp);
+	/* XXXRW: Not clear if this is adequate. */
 	return 0;
 }
 
--- //depot/vendor/freebsd/src/sys/netinet/ip_encap.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netinet/ip_encap.c	2005/02/27 16:23:38
@@ -106,8 +106,7 @@
 LIST_HEAD(, encaptab) encaptab = LIST_HEAD_INITIALIZER(&encaptab);
 
 /*
- * We currently keey encap_init() for source code compatibility reasons --
- * it's referenced by KAME pieces in netinet6.
+ * XXXRW: encap_init() was entirely useless, so I deleted it.
  */
 void
 encap_init()
@@ -185,6 +184,10 @@
 	}
 	mtx_unlock(&encapmtx);
 
+	/*
+	 * XXXRW: Need drain mechanism to prevent the encapsulation
+	 * entry from being released while in use.
+	 */
 	if (match) {
 		/* found a match, "match" has the best one */
 		psw = match->psw;
@@ -255,6 +258,10 @@
 	}
 	mtx_unlock(&encapmtx);
 
+	/*
+	 * XXXRW: Need drain mechanism so the encap entry isn't freed
+	 * while in use.
+	 */
 	if (match) {
 		/* found a match */
 		psw = (const struct ip6protosw *)match->psw;
--- //depot/vendor/freebsd/src/sys/netinet/ip_encap.h	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netinet/ip_encap.h	2005/02/27 16:23:38
@@ -35,6 +35,15 @@
 
 #ifdef _KERNEL
 
+/*
+ * This structure is entirely static after registration, and other than
+ * its entry in the encapsulation table, requires no locking.  The chain
+ * field is locked using the global encapmtx.
+ *
+ * XXXRW: Need to add a refcount/drain mechanism so that encapsulation
+ * entries can't be removed while in use.  This likely requires a
+ * refcount and cv to wait for it to drain, or an sx lock.
+ */
 struct encaptab {
 	LIST_ENTRY(encaptab) chain;
 	int af;
--- //depot/vendor/freebsd/src/sys/netinet/ip_fastfwd.c	2005/05/04 13:11:32
+++ //depot/user/rwatson/netperf/sys/netinet/ip_fastfwd.c	2005/06/01 10:10:04
@@ -482,6 +482,7 @@
 			 * "ours"-label.
 			 */
 			m->m_flags |= M_FASTFWD_OURS;
+			/* XXX statistic */
 			if (ro.ro_rt)
 				RTFREE(ro.ro_rt);
 			return 0;
--- //depot/vendor/freebsd/src/sys/netinet/ip_id.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netinet/ip_id.c	2005/02/27 16:23:38
@@ -61,7 +61,10 @@
 #include <sys/param.h>
 #include <sys/time.h>
 #include <sys/kernel.h>
+#include <sys/pcpu.h>
+#include <sys/proc.h>
 #include <sys/random.h>
+#include <sys/systm.h>
 
 #define RU_OUT  180		/* Time after wich will be reseeded */
 #define RU_MAX	30000		/* Uniq cycle, avoid blackjack prediction */
@@ -77,19 +80,24 @@
 	2729
 };
 
-static u_int16_t ru_x;
-static u_int16_t ru_seed, ru_seed2;
-static u_int16_t ru_a, ru_b;
-static u_int16_t ru_g;
-static u_int16_t ru_counter = 0;
-static u_int16_t ru_msb = 0;
-static long ru_reseed;
-static u_int32_t tmp;		/* Storage for unused random */
+struct random_pcpu {
+	u_int16_t	ru_x;
+	u_int16_t	ru_seed, ru_seed2;
+	u_int16_t	ru_a, ru_b;
+	u_int16_t	ru_g;
+	u_int16_t	ru_counter;
+	u_int16_t	ru_msb;
+	long		ru_reseed;
+	u_int32_t	tmp;		/* Storage for unused random */
+};
+
+static struct random_pcpu random_pcpu[MAXCPU];
 
 static u_int16_t pmod(u_int16_t, u_int16_t, u_int16_t);
-static void ip_initid(void);
+static void ip_initid(struct random_pcpu *rp);
 u_int16_t ip_randomid(void);
 
+
 /*
  * Do a fast modular exponation, returned value will be in the range
  * of 0 - (mod-1)
@@ -128,32 +136,32 @@
  * application does not have to worry about it.
  */
 static void
-ip_initid(void)
+ip_initid(struct random_pcpu *rp)
 {
 	u_int16_t j, i;
 	int noprime = 1;
 	struct timeval time;
 
 	getmicrotime(&time);
-	read_random((void *) &tmp, sizeof(tmp));
-	ru_x = (tmp & 0xFFFF) % RU_M;
+	read_random((void *) &rp->tmp, sizeof(rp->tmp));
+	rp->ru_x = (rp->tmp & 0xFFFF) % RU_M;
 
 	/* 15 bits of random seed */
-	ru_seed = (tmp >> 16) & 0x7FFF;
-	read_random((void *) &tmp, sizeof(tmp));
-	ru_seed2 = tmp & 0x7FFF;
+	rp->ru_seed = (rp->tmp >> 16) & 0x7FFF;
+	read_random((void *) &rp->tmp, sizeof(rp->tmp));
+	rp->ru_seed2 = rp->tmp & 0x7FFF;
 
-	read_random((void *) &tmp, sizeof(tmp));
+	read_random((void *) &rp->tmp, sizeof(rp->tmp));
 
 	/* Determine the LCG we use */
-	ru_b = (tmp & 0xfffe) | 1;
-	ru_a = pmod(RU_AGEN, (tmp >> 16) & 0xfffe, RU_M);
-	while (ru_b % 3 == 0)
-	  ru_b += 2;
+	rp->ru_b = (rp->tmp & 0xfffe) | 1;
+	rp->ru_a = pmod(RU_AGEN, (rp->tmp >> 16) & 0xfffe, RU_M);
+	while (rp->ru_b % 3 == 0)
+	  rp->ru_b += 2;
 
-	read_random((void *) &tmp, sizeof(tmp));
-	j = tmp % RU_N;
-	tmp = tmp >> 16;
+	read_random((void *) &rp->tmp, sizeof(rp->tmp));
+	j = rp->tmp % RU_N;
+	rp->tmp = rp->tmp >> 16;
 
 	/*
 	 * Do a fast gcd(j,RU_N-1), so we can find a j with
@@ -172,38 +180,46 @@
 			j = (j+1) % RU_N;
 	}
 
-	ru_g = pmod(RU_GEN,j,RU_N);
-	ru_counter = 0;
+	rp->ru_g = pmod(RU_GEN,j,RU_N);
+	rp->ru_counter = 0;
 
-	ru_reseed = time.tv_sec + RU_OUT;
-	ru_msb = ru_msb == 0x8000 ? 0 : 0x8000;
+	rp->ru_reseed = time.tv_sec + RU_OUT;
+	rp->ru_msb = rp->ru_msb == 0x8000 ? 0 : 0x8000;
 }
 
 u_int16_t
 ip_randomid(void)
 {
+	struct random_pcpu *rp;
+	struct timeval time;
+	u_int16_t retval;
 	int i, n;
-	struct timeval time;
 
-	/* XXX not reentrant */
 	getmicrotime(&time);
-	if (ru_counter >= RU_MAX || time.tv_sec > ru_reseed)
-		ip_initid();
+
+	critical_enter();
+	rp = &random_pcpu[curcpu];
+
+	if (rp->ru_counter >= RU_MAX || time.tv_sec > rp->ru_reseed)
+		ip_initid(rp);
 
-	if (!tmp)
-		read_random((void *) &tmp, sizeof(tmp));
+	if (!rp->tmp)
+		read_random((void *) &rp->tmp, sizeof(rp->tmp));
 
 	/* Skip a random number of ids */
-	n = tmp & 0x3; tmp = tmp >> 2;
-	if (ru_counter + n >= RU_MAX)
-		ip_initid();
+	n = rp->tmp & 0x3; rp->tmp = rp->tmp >> 2;
+	if (rp->ru_counter + n >= RU_MAX)
+		ip_initid(rp);
 
 	for (i = 0; i <= n; i++)
 		/* Linear Congruential Generator */
-		ru_x = (ru_a*ru_x + ru_b) % RU_M;
+		rp->ru_x = (rp->ru_a*rp->ru_x + rp->ru_b) % RU_M;
 
-	ru_counter += i;
+	rp->ru_counter += i;
 
-	return (ru_seed ^ pmod(ru_g,ru_seed2 ^ ru_x,RU_N)) | ru_msb;
+	retval = (rp->ru_seed ^ pmod(rp->ru_g,rp->ru_seed2 ^ rp->ru_x,RU_N))
+	    | rp->ru_msb;
+	critical_exit();
+	return (retval);
 }
 
--- //depot/vendor/freebsd/src/sys/netinet/ip_output.c	2005/07/05 23:40:38
+++ //depot/user/rwatson/netperf/sys/netinet/ip_output.c	2005/07/19 11:47:08
@@ -1149,7 +1149,8 @@
 	struct sockopt *sopt;
 {
 	struct	inpcb *inp = sotoinpcb(so);
-	int	error, optval;
+	struct	mbuf *m, *mopt;
+	int	error, optval, tmp;
 
 	error = optval = 0;
 	if (sopt->sopt_level != IPPROTO_IP) {
@@ -1164,7 +1165,6 @@
 		case IP_RETOPTS:
 #endif
 		{
-			struct mbuf *m;
 			if (sopt->sopt_valsize > MLEN) {
 				error = EMSGSIZE;
 				break;
@@ -1290,7 +1290,6 @@
 			caddr_t req;
 			size_t len = 0;
 			int priv;
-			struct mbuf *m;
 			int optname;
 
 			if ((error = soopt_getm(sopt, &m)) != 0) /* XXX */
@@ -1302,7 +1301,9 @@
 			req = mtod(m, caddr_t);
 			len = m->m_len;
 			optname = sopt->sopt_name;
+			INP_LOCK(inp);
 			error = ipsec4_set_policy(inp, optname, req, len, priv);
+			INP_UNLOCK(inp);
 			m_freem(m);
 			break;
 		}
@@ -1318,13 +1319,39 @@
 		switch (sopt->sopt_name) {
 		case IP_OPTIONS:
 		case IP_RETOPTS:
-			if (inp->inp_options)
-				error = sooptcopyout(sopt, 
-						     mtod(inp->inp_options,
-							  char *),
-						     inp->inp_options->m_len);
-			else
+			/*
+			 * Make a temporary copy of the options in a local
+			 * mbuf while holding the lock so that the copyout()
+			 * can be done without a lock.  Optimistically assume
+			 * options will be present, so always allocate the
+			 * mbuf and grab the lock.  If there's no data, it
+			 * doesn't matter if the allocation fails.
+			 */
+			MGET(m, sopt->sopt_td ? M_TRYWAIT : M_DONTWAIT,
+			    MT_HEADER);
+			INP_LOCK(inp);
+			mopt = inp->inp_options;
+			if (mopt == NULL) {
+				INP_UNLOCK(inp);
+				if (m != NULL)
+					m_freem(m);
+				sopt->sopt_valsize = 0;
+				break;
+			}
+			if (m == NULL) {
+				INP_UNLOCK(inp);
 				sopt->sopt_valsize = 0;
+				error = ENOBUFS;
+				break;
+			}
+			KASSERT(mopt->m_len <= MLEN,
+			    ("ip_ctloutput: m_len > MLEN"));
+			bcopy(mtod(mopt, char *), mtod(m, char *),
+			    mopt->m_len);
+			m->m_len = mopt->m_len;
+			INP_UNLOCK(inp);
+			error = sooptcopyout(sopt, mtod(m, char *), m->m_len);
+			m_freem(m);
 			break;
 
 		case IP_TOS:
@@ -1370,9 +1397,14 @@
 				break;
 
 			case IP_PORTRANGE:
-				if (inp->inp_flags & INP_HIGHPORT)
+				/*
+				 * We make a local copy to avoid multiple
+				 * reads without locking.
+				 */
+				tmp = inp->inp_flags;
+				if (tmp & INP_HIGHPORT)
 					optval = IP_PORTRANGE_HIGH;
-				else if (inp->inp_flags & INP_LOWPORT)
+				else if (tmp & INP_LOWPORT)
 					optval = IP_PORTRANGE_LOW;
 				else
 					optval = 0;
@@ -1585,12 +1617,14 @@
 	imo = inp->inp_moptions;
 	if (imo == NULL) {
 		/*
-		 * No multicast option buffer attached to the pcb;
-		 * allocate one and initialize to default values.
+		 * No multicast option buffer attached to the pcb; allocate
+		 * one and initialize to default values.  Make sure to handle
+		 * losing this race, as malloc() may sleep.
+		 *
+		 * XXXRW: inpcb locking here.
 		 */
 		imo = (struct ip_moptions*)malloc(sizeof(*imo), M_IPMOPTS,
 		    M_WAITOK);
-
 		if (imo == NULL)
 			return (ENOBUFS);
 		inp->inp_moptions = imo;
@@ -1647,11 +1681,13 @@
 			error = EADDRNOTAVAIL;
 			break;
 		}
+		INP_LOCK(inp);
 		imo->imo_multicast_ifp = ifp;
 		if (ifindex)
 			imo->imo_multicast_addr = addr;
 		else
 			imo->imo_multicast_addr.s_addr = INADDR_ANY;
+		INP_UNLOCK(inp);
 		splx(s);
 		break;
 
@@ -1754,6 +1790,7 @@
 		 * See if the membership already exists or if all the
 		 * membership slots are full.
 		 */
+		INP_LOCK(inp);
 		for (i = 0; i < imo->imo_num_memberships; ++i) {
 			if (imo->imo_membership[i]->inm_ifp == ifp &&
 			    imo->imo_membership[i]->inm_addr.s_addr
@@ -1761,11 +1798,13 @@
 				break;
 		}
 		if (i < imo->imo_num_memberships) {
+			INP_UNLOCK(inp);
 			error = EADDRINUSE;
 			splx(s);
 			break;
 		}
 		if (i == IP_MAX_MEMBERSHIPS) {
+			INP_UNLOCK(inp);
 			error = ETOOMANYREFS;
 			splx(s);
 			break;
@@ -1774,8 +1813,10 @@
 		 * Everything looks good; add a new record to the multicast
 		 * address list for the given interface.
 		 */
+		INP_UNLOCK(inp);	/* XXXRW: in_addmulti() may sleep? */
 		if ((imo->imo_membership[i] =
 		    in_addmulti(&mreq.imr_multiaddr, ifp)) == NULL) {
+			
 			error = ENOBUFS;
 			splx(s);
 			break;
@@ -1816,6 +1857,7 @@
 		/*
 		 * Find the membership in the membership array.
 		 */
+		INP_LOCK(inp);
 		for (i = 0; i < imo->imo_num_memberships; ++i) {
 			if ((ifp == NULL ||
 			     imo->imo_membership[i]->inm_ifp == ifp) &&
@@ -1824,6 +1866,7 @@
 				break;
 		}
 		if (i == imo->imo_num_memberships) {
+			INP_UNLOCK(inp);
 			error = EADDRNOTAVAIL;
 			splx(s);
 			break;
@@ -1832,6 +1875,7 @@
 		 * Give up the multicast address record to which the
 		 * membership points.
 		 */
+		INP_UNLOCK(inp);	/* XXXRW: in_delmulti() may sleep? */
 		in_delmulti(imo->imo_membership[i]);
 		/*
 		 * Remove the gap in the membership array.
@@ -1850,6 +1894,7 @@
 	/*
 	 * If all options have default values, no need to keep the mbuf.
 	 */
+	INP_LOCK(inp);
 	if (imo->imo_multicast_ifp == NULL &&
 	    imo->imo_multicast_vif == -1 &&
 	    imo->imo_multicast_ttl == IP_DEFAULT_MULTICAST_TTL &&
@@ -1858,6 +1903,7 @@
 		free(inp->inp_moptions, M_IPMOPTS);
 		inp->inp_moptions = NULL;
 	}
+	INP_UNLOCK(inp);
 
 	return (error);
 }
@@ -1879,7 +1925,9 @@
 
 	error = 0;
 	switch (sopt->sopt_name) {
-	case IP_MULTICAST_VIF: 
+	case IP_MULTICAST_VIF:
+		INP_LOCK(inp);
+		imo = inp->inp_moptions;
 		if (imo != NULL)
 			optval = imo->imo_multicast_vif;
 		else
@@ -1889,6 +1937,8 @@
 		break;
 
 	case IP_MULTICAST_IF:
+		INP_LOCK(inp);
+		imo = inp->inp_moptions;
 		if (imo == NULL || imo->imo_multicast_ifp == NULL)
 			addr.s_addr = INADDR_ANY;
 		else if (imo->imo_multicast_addr.s_addr) {
@@ -1904,7 +1954,9 @@
 		break;
 
 	case IP_MULTICAST_TTL:
-		if (imo == 0)
+		INP_LOCK(inp);
+		imo = inp->inp_moptions;
+		if (imo == NULL)
 			optval = coptval = IP_DEFAULT_MULTICAST_TTL;
 		else
 			optval = coptval = imo->imo_multicast_ttl;
@@ -1916,7 +1968,9 @@
 		break;
 
 	case IP_MULTICAST_LOOP:
-		if (imo == 0)
+		INP_LOCK(inp);
+		imo = inp->inp_moptions;
+		if (imo == NULL)
 			optval = coptval = IP_DEFAULT_MULTICAST_LOOP;
 		else
 			optval = coptval = imo->imo_multicast_loop;
--- //depot/vendor/freebsd/src/sys/netinet/raw_ip.c	2005/06/01 11:40:22
+++ //depot/user/rwatson/netperf/sys/netinet/raw_ip.c	2005/07/05 14:55:33
@@ -86,6 +86,9 @@
  * so leave them not initialized and rely on BSS being set to 0.
  */
 
+/*
+ * XXXRW: Locking for mrouter bits?
+ */
 /* The socket used to communicate with the multicast routing daemon.  */
 struct socket  *ip_mrouter;
 
@@ -660,6 +663,7 @@
 	}
 	INP_LOCK(inp);
 	soisdisconnected(so);
+	/* Unlocked read. */
 	if (so->so_state & SS_NOFDREF)
 		rip_pcbdetach(so, inp);
 	else
@@ -671,6 +675,8 @@
 static int
 rip_disconnect(struct socket *so)
 {
+
+	/* Unlocked read. */
 	if ((so->so_state & SS_ISCONNECTED) == 0)
 		return ENOTCONN;
 	return rip_abort(so);
@@ -767,6 +773,7 @@
 
 	INP_INFO_WLOCK(&ripcbinfo);
 	inp = sotoinpcb(so);
+	/* Unlocked read. */
 	if (so->so_state & SS_ISCONNECTED) {
 		if (nam) {
 			INP_INFO_WUNLOCK(&ripcbinfo);
--- //depot/vendor/freebsd/src/sys/netinet/tcp_debug.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_debug.c	2005/02/27 16:23:38
@@ -50,6 +50,7 @@
 #include <sys/systm.h>
 #include <sys/mbuf.h>
 #include <sys/protosw.h>
+#include <sys/mbuf.h>
 #include <sys/socket.h>
 
 #include <netinet/in.h>
--- //depot/vendor/freebsd/src/sys/netinet/tcp_hostcache.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_hostcache.c	2005/02/27 16:23:38
@@ -250,7 +250,8 @@
 	 * Set up periodic cache cleanup.
 	 */
 	callout_init(&tcp_hc_callout, CALLOUT_MPSAFE);
-	callout_reset(&tcp_hc_callout, TCP_HOSTCACHE_PRUNE * hz, tcp_hc_purge, 0);
+	callout_reset(&tcp_hc_callout, TCP_HOSTCACHE_PRUNE * hz, tcp_hc_purge,
+	    NULL);
 }
 
 /*
@@ -287,6 +288,9 @@
 
 	/*
 	 * circle through entries in bucket row looking for a match
+	 *
+	 * XXXRW: Wouldn't it be faster to let the compiler do the comparison
+	 * if the data types are approrpiate, rather than using memcmp()?
 	 */
 	TAILQ_FOREACH(hc_entry, &hc_head->hch_bucket, rmx_q) {
 		if (inc->inc_isipv6) {
--- //depot/vendor/freebsd/src/sys/netinet/tcp_input.c	2005/07/05 19:26:06
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_input.c	2005/07/19 11:47:08
@@ -1231,6 +1231,7 @@
 						      tcp_timer_rexmt, tp);
 
 				sowwakeup(so);
+				/* Unlocked read. */
 				if (so->so_snd.sb_cc)
 					(void) tcp_output(tp);
 				goto check_delack;
@@ -1655,6 +1656,7 @@
 	 * If new data are received on a connection after the
 	 * user processes are gone, then RST the other end.
 	 */
+	/* Unlocked read. */
 	if ((so->so_state & SS_NOFDREF) &&
 	    tp->t_state > TCPS_CLOSE_WAIT && tlen) {
 		KASSERT(headlocked, ("trimthenstep6: tcp_close.3: head not "
@@ -2159,6 +2161,7 @@
 		 * we should release the tp also, and use a
 		 * compressed state.
 		 */
+				/* Unlocked read. */
 				if (so->so_rcv.sb_state & SBS_CANTRCVMORE) {
 					soisdisconnected(so);
 					callout_reset(tp->tt_2msl, tcp_maxidle,
@@ -2535,6 +2538,11 @@
 
 	if (tp)
 		INP_UNLOCK(inp);
+	/*
+	 * XXXRW: Added assertion at dropwithreset label because I believe
+	 * the head should always be locked here.  If true, this can be
+	 * changed to an unconditional unlock.
+	 */
 	if (headlocked)
 		INP_INFO_WUNLOCK(&tcbinfo);
 	return;
--- //depot/vendor/freebsd/src/sys/netinet/tcp_output.c	2005/05/21 00:40:18
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_output.c	2005/06/01 10:10:04
@@ -275,6 +275,7 @@
 			 * to send then the probe will be the FIN
 			 * itself.
 			 */
+			/* Unlocked read of sb_cc. */
 			if (off < so->so_snd.sb_cc)
 				flags &= ~TH_FIN;
 			sendwin = 1;
@@ -381,6 +382,7 @@
 		len = tp->t_maxseg;
 		sendalot = 1;
 	}
+	/* Unlocked read of sb_cc. */
 	if (sack_rxmit) {
 		if (SEQ_LT(p->rxmit + len, tp->snd_una + so->so_snd.sb_cc))
 			flags &= ~TH_FIN;
@@ -413,6 +415,7 @@
 		 *
 		 * note: the len + off check is almost certainly unnecessary.
 		 */
+		/* Unlocked read of sb_cc. */
 		if (!(tp->t_flags & TF_MORETOCOME) &&	/* normal case */
 		    (idle || (tp->t_flags & TF_NODELAY)) &&
 		    len + off >= so->so_snd.sb_cc &&
@@ -504,6 +507,7 @@
 	 * if window is nonzero, transmit what we can,
 	 * otherwise force out a byte.
 	 */
+	/* Unlocked read of sb_cc. */
 	if (so->so_snd.sb_cc && !callout_active(tp->tt_rexmt) &&
 	    !callout_active(tp->tt_persist)) {
 		tp->t_rxtshift = 0;
@@ -786,6 +790,7 @@
 		 * give data to the user when a buffer fills or
 		 * a PUSH comes in.)
 		 */
+		/* Unlocked read of sb_cc. */
 		if (off + len == so->so_snd.sb_cc)
 			flags |= TH_PUSH;
 		SOCKBUF_UNLOCK(&so->so_snd);
--- //depot/vendor/freebsd/src/sys/netinet/tcp_subr.c	2005/07/01 22:55:27
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_subr.c	2005/07/05 14:55:33
@@ -1466,6 +1466,10 @@
 #endif /* INET6 */
 
 	INP_LOCK_ASSERT(inp);
+
+	/*
+	 * XXXRW: How often and why is it that tp could be non-NULL here?
+	 */
 	if (tp != NULL) {
 #ifdef INET6
 		isipv6 = (tp->t_inpcb->inp_vflag & INP_IPV6) != 0;
